package de.edotzlaff.detection.detektion;


import android.os.Build;
import android.util.Log;

import androidx.annotation.RequiresApi;
import de.edotzlaff.detection.detektion.berechnung.Endpunkt;
import de.edotzlaff.detection.detektion.berechnung.EndpunktVerbindung;
import de.edotzlaff.detection.detektion.berechnung.EpizentrumRechnung;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Objects;


public class Erdbeben {

    //ToDO anpassen an Szenario umso mehr umso wahrscheinlich ein Ergebnis, oder Abbruchbedingung mit do while
    public static final Integer SCHLEIFENDURCHLAUFTE = 8000;
    private static final String TAG = "ERDBEBEN";

    private Epizentrum epizentrum;
    private EpizentrumRechnung epizentrumRechnung;
    private HashMap<String, Detektionssignal> nutzerDaten;
    private Detektionssignal erstesDetektionssignal;

    public Erdbeben() {

        nutzerDaten = new HashMap<>();
        epizentrumRechnung = new EpizentrumRechnung();
        epizentrum = new Epizentrum();
    }

    public int addDetektionssignal(Detektionssignal detektionssignal) {
        nutzerDaten.put(detektionssignal.getDeviceId(), detektionssignal);
        return nutzerDaten.size();
    }

    public void addDetektionssignalList(ArrayList<Detektionssignal> detektionssignale)
    {
        for (int i = 0; i< detektionssignale.size(); i++)
        {
            nutzerDaten.put(detektionssignale.get(i).getDeviceId()+"i",detektionssignale.get(i));
        }
        Log.i(TAG, "addDetektionssignalList: " + nutzerDaten.size());
    }

    @RequiresApi(api = Build.VERSION_CODES.O)
    public Epizentrum ermittleEpizentrum() {

        ArrayList<Detektionssignal> rechenListe = new ArrayList<>();
        nutzerDaten.forEach((key, value) -> rechenListe.add(value));
        //Initialisierung der Rechung - First Element mit delta r + alle möglichen EndpunktKombinationen (einfach)
        erstesDetektionssignal = epizentrumRechnung.ermittleErstesDetektionssignal(rechenListe);
        ArrayList<Endpunkt> berechnungsEndpunkte = epizentrumRechnung.initEndpunkte(rechenListe, erstesDetektionssignal);

        ArrayList<EndpunktVerbindung> endpunktKonbinationen = epizentrumRechnung.ermittleEndpunktKonbinationen(berechnungsEndpunkte);

        //ToDo Vernünftiger Endpunkt überlegen bzw. bis wann abgebrochen wird -> Umzug in Berechnungs
        for (int i = 0; i <= SCHLEIFENDURCHLAUFTE; i++) {
            if (epizentrumRechnung.genuegendSchnittpunktevorhanden(endpunktKonbinationen)) {
                epizentrum = epizentrumRechnung.ueberpruefeObEpizentrum(endpunktKonbinationen);
                //ToDo set EnstehungsZeitpunkt -> (Bezugszeit, Koord, Koord, v;)
                if (!Objects.isNull(epizentrum)) {
                    epizentrum.setEntstehungsZeitpunkt(epizentrumRechnung.berechneEntstehungsZeitpunktLongLatt(erstesDetektionssignal, epizentrum.getKoordinaten()));
                    return epizentrum;
                }
            }
            epizentrumRechnung.erhoheRadius(berechnungsEndpunkte);
        }
        return null;
    }

}
